//*****************************************************************************
//* Copyright (c) 2011 Miday Workshop All rights reserved.
//*
//* File: Ribbon.h
//*****************************************************************************

#define PATH_SIZE       1024

//^Cg
#ifdef ETOMAIL
#define WIND_TITLE  L"EtoMail Ribbono^c["
#define CHK_TITLE2  L"{"
#define CHK_TITLE3  L"p"
#else
#define WIND_TITLE  L"EtoWeb Ribbono^c["
#define CHK_TITLE2  L"Wiki"
#define CHK_TITLE3  L"Html"
#endif

//ƗptH_[
#define WORK_FOLDER     L"\\EtoMWork"

//ҏWǉf[^
#define ADD_XML1_FILE   L"[Content_Types].xml"
#define ADD_XML1_KEY    "</Types>"
#define ADD_XML1_TAG    "<Default Extension=\"png\" ContentType=\"image/.png\"/>"
#define ADD_XML2_FILE   L"_rels\\.rels"
#define ADD_XML2_KEY    "</Relationships>"
#ifdef ETOMAIL
#define ADD_XML2_TAG    "<Relationship Id=\"EtoMailUIRelID\" Type=\"http://schemas.microsoft.com/office/2006/relationships/ui/extensibility\" Target=\"EtoMailUI/EtoMailUI.xml\"/>"
#else
#define ADD_XML2_TAG    "<Relationship Id=\"EtoWebUIRelID\" Type=\"http://schemas.microsoft.com/office/2006/relationships/ui/extensibility\" Target=\"EtoWebUI/EtoWebUI.xml\"/>"
#endif

//ǉ̃tH_[
#ifdef ETOMAIL
#define ADD_FOLDER      L"EtoMailUI"
#else
#define ADD_FOLDER      L"EtoWebUI"
#endif

#define ADD_SUBFOLDER1   L"_rels"
#define ADD_SUBFOLDER2   L"images"

//ǉ̃t@C
#ifdef ETOMAIL
#define ADD_ZIP1_FILE  L"EtoMailUI.xml"
#define ADD_ZIP2_FILE  L"\\EtoMailUI.xml.rels"
#else
#define ADD_ZIP1_FILE  L"EtoWebUI.xml"
#define ADD_ZIP2_FILE  L"\\EtoWebUI.xml.rels"
#endif

//ǉ̃t@C̓e1
#define ADD_ZIP1_DATA1  "<customUI xmlns=\"http://schemas.microsoft.com/office/2006/01/customui\"> \n  <ribbon startFromScratch=\"false\"> \n    <tabs> \n"
#ifdef ETOMAIL
#define ADD_ZIP1_DATA2  "      <tab id=\"CustomTab\" label=\"EtoMail\"> \n        <group id=\"SimpleControls\" label=\"EtoMail Group\"> \n"
#define ADD_ZIP1_DATA3  "          <button id=\"EtoMail1\" image=\"EtoMaili1\" size=\"large\" \n            label=\"EtoMail\" \n            onAction=\"EtoMail_Module.EtoMail_CALL21\" /> \n"
#define ADD_ZIP1_DATA4  "          <button id=\"EtoMail2\" image=\"EtoMaili2\" size=\"large\" \n            label=\"EtoMailE\" \n            onAction=\"EtoMail_Module.EtoMail_CALL22\" /> \n"
#else
#define ADD_ZIP1_DATA2  "      <tab id=\"CustomTab\" label=\"EtoWeb\"> \n        <group id=\"SimpleControls\" label=\"EtoWeb Group\"> \n"
#define ADD_ZIP1_DATA3  "          <button id=\"EtoWeb1\" image=\"EtoWikii\" size=\"large\" \n            label=\"EtoWiki\" \n            onAction=\"EtoWeb_Module.EtoWeb_CALL21\" /> \n"
#define ADD_ZIP1_DATA4  "          <button id=\"EtoWeb2\" image=\"EtoHtmli\" size=\"large\" \n            label=\"EtoHtml\" \n            onAction=\"EtoWeb_Module.EtoWeb_CALL22\" /> \n"
#endif

#define ADD_ZIP1_DATA5  "        </group> \n      </tab> \n    </tabs> \n  </ribbon> \n</customUI>"

//ǉ̃t@C̓e2
#define ADD_ZIP2_URL    " Type=\"http://schemas.openxmlformats.org/officeDocument/2006/relationships/image\""

#define ADD_ZIP2_DATA1  "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?>\n<Relationships xmlns=\"http://schemas.openxmlformats.org/package/2006/relationships\">"
#ifdef ETOMAIL
#define ADD_ZIP2_DATA2  "<Relationship Id=\"EtoMaili1\""
#define ADD_ZIP2_DATA3  ADD_ZIP2_URL
#define ADD_ZIP2_DATA4  " Target=\"images/EtoMail_j.png\"/>"

#define ADD_ZIP2_DATA5  "<Relationship Id=\"EtoMaili2\""
#define ADD_ZIP2_DATA6  ADD_ZIP2_URL
#define ADD_ZIP2_DATA7  " Target=\"images/EtoMail_e.png\"/>"
#else
#define ADD_ZIP2_DATA2  "<Relationship Id=\"EtoWikii\""
#define ADD_ZIP2_DATA3  ADD_ZIP2_URL
#define ADD_ZIP2_DATA4  " Target=\"images/EtoWiki.png\"/>"

#define ADD_ZIP2_DATA5  "<Relationship Id=\"EtoHtmli\""
#define ADD_ZIP2_DATA6  ADD_ZIP2_URL
#define ADD_ZIP2_DATA7  " Target=\"images/EtoHtml.png\"/>"
#endif
#define ADD_ZIP2_DATA8  "</Relationships>"

//摜f[^
#ifdef ETOMAIL
#define FROMJ_IMAGE     L"EtoMail_j.png"
#define FROME_IMAGE     L"EtoMail_e.png"
#else
#define FROMJ_IMAGE     L"EtoWiki.png"
#define FROME_IMAGE     L"EtoHtml.png"
#endif

#define SKELETON_IMAGE  L"wi\\"
#define WHITE_IMAGE     L"wi\\"

#if !defined(_MSC_VER) || _MSC_VER < 1400
#define WCSCPY(a,len,b) wcscpy(a, b)
#define WCSCAT(a,len,b) wcscat(a, b)
#else
#define WCSCPY(a,len,b) wcscpy_s(a, len, b)
#define WCSCAT(a,len,b) wcscat_s(a, len, b)
#endif
