//*****************************************************************************
//* Copyright (c) 2011 Miday Workshop All rights reserved.
//*
//* File: RibbonEdit.cpp
//*****************************************************************************

#include <windows.h>
#include <stdio.h>
#include <shlobj.h>
#include "Ribbon.h"
#include "resource.h"

extern unsigned int FileSizeGet(wchar_t *file_name);
extern bool FolderCopy(IShellDispatch *pDispatch, wchar_t *fromfolder_name, wchar_t *tofolder_name);

extern wchar_t Addin_path[PATH_SIZE], Toolkit_path[PATH_SIZE], Temp_path[PATH_SIZE];
static wchar_t addinfile[PATH_SIZE], addinzipfile[PATH_SIZE];
static int Stepflag1, Stepflag2;

//==============================================================================
//ZIPt@C̒ҏW
//==============================================================================
bool RibbonEdit(HWND hWnd, IShellDispatch *pDispatch, wchar_t *tmp_folder, int *chkflag) {
//hWnd@@@@@@@EChEnh
//*pDispatch@@@@IuWFNg̃|C^
//*tmp_folder@@@ ƗptH_[
//*chkflag@@@@@Rs[摜̃tO
//߂l@TRUE  
//@@@@FALSE s
	wchar_t filename1[PATH_SIZE], filename2[PATH_SIZE];
	BYTE data[5000];
	int len, ia, ib;
	FILE *fp;

	//XML̕ҏW1
	WCSCPY(filename1, sizeof(filename1), tmp_folder);
	WCSCAT(filename1, sizeof(filename1), L"\\");
	WCSCAT(filename1, sizeof(filename1), ADD_XML1_FILE);
#if !defined(_MSC_VER) || _MSC_VER < 1400
	if ( (fp = _wfopen(filename1, L"rb")) == NULL ) {
#else
	if ( _wfopen_s(&fp, filename1, L"rb") != 0 ) {
#endif
		MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
		fclose(fp);
		return FALSE;
	}
//	len = read(fd, data, sizeof(data));
	if ( (len = fread(data, sizeof(BYTE), sizeof(data), fp)) <= 0 ) {
		MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
		fclose(fp);
		return FALSE;
	}
	fclose(fp);

	for(ia=0; ia<=len-(int)strlen(ADD_XML1_TAG); ia++) {
		if ( memcmp(&data[ia], ADD_XML1_TAG, strlen(ADD_XML1_TAG)) == 0 ) {
			MessageBox(hWnd, L"{͊ɓo^Ă܂B", WIND_TITLE, MB_ICONSTOP | MB_OK);
			return FALSE;//d`
		}
	}

#if !defined(_MSC_VER) || _MSC_VER < 1400
	if ( (fp = _wfopen(filename1, L"wb")) == NULL ) {
#else
	if ( _wfopen_s(&fp, filename1, L"wb") != 0 ) {
#endif
		MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
		fclose(fp);
		return FALSE;
	}
//	write(fd, data,         len-sizeof(ADD_XML1_KEY)+1);
//	write(fd, ADD_XML1_TAG, sizeof(ADD_XML1_TAG)-1);
//	write(fd, ADD_XML1_KEY, sizeof(ADD_XML1_KEY)-1);
	if ( fwrite(data,         sizeof(BYTE), len-sizeof(ADD_XML1_KEY)+1, fp) < len-sizeof(ADD_XML1_KEY)+1 ) {
		MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
		fclose(fp);
		return FALSE;
	}
	if ( fwrite(ADD_XML1_TAG, sizeof(BYTE), sizeof(ADD_XML1_TAG)-1,     fp) < sizeof(ADD_XML1_TAG)-1 ) {
		MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
		fclose(fp);
		return FALSE;
	}
	if ( fwrite(ADD_XML1_KEY, sizeof(BYTE), sizeof(ADD_XML1_KEY)-1,     fp) < sizeof(ADD_XML1_KEY)-1 ) {
		MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
		fclose(fp);
		return FALSE;
	}
	fclose(fp);

	//XML̕ҏW2
	WCSCPY(filename1, sizeof(filename1), tmp_folder);
	WCSCAT(filename1, sizeof(filename1), L"\\");
	WCSCAT(filename1, sizeof(filename1), ADD_XML2_FILE);
#if !defined(_MSC_VER) || _MSC_VER < 1400
	if ( (fp = _wfopen(filename1, L"rb")) == NULL ) {
#else
	if ( _wfopen_s(&fp, filename1, L"rb") != 0 ) {
#endif
		MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
		fclose(fp);
		return FALSE;
	}
//	len = read(fd, data, sizeof(data));
	if ( (len = fread(data, sizeof(BYTE), sizeof(data), fp)) <= 0 ) {
		MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
		fclose(fp);
		return FALSE;
	}
	fclose(fp);

	for(ia=0; ia<=len-(int)strlen(ADD_XML2_TAG); ia++) {
		if ( memcmp(&data[ia], ADD_XML2_TAG, strlen(ADD_XML2_TAG)) == 0 ) {
			MessageBox(hWnd, L"{͊ɓo^Ă܂B", WIND_TITLE, MB_ICONSTOP | MB_OK);
			return FALSE;//d`
		}
	}

#if !defined(_MSC_VER) || _MSC_VER < 1400
	if ( (fp = _wfopen(filename1, L"wb")) == NULL ) {
#else
	if ( _wfopen_s(&fp, filename1, L"wb") != 0 ) {
#endif
		MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
		fclose(fp);
		return FALSE;
	}
//	write(fd, data,         len-sizeof(ADD_XML2_KEY)+1);
//	write(fd, ADD_XML2_TAG, sizeof(ADD_XML2_TAG)-1);
//	write(fd, ADD_XML2_KEY, sizeof(ADD_XML2_KEY)-1);
	if ( fwrite(data,         sizeof(BYTE), len-sizeof(ADD_XML2_KEY)+1, fp) < len-sizeof(ADD_XML2_KEY)+1 ) {
		MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
		fclose(fp);
		return FALSE;
	}
	if ( fwrite(ADD_XML2_TAG, sizeof(BYTE), sizeof(ADD_XML2_TAG)-1,     fp) < sizeof(ADD_XML2_TAG)-1 ) {
		MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
		fclose(fp);
		return FALSE;
	}
	if ( fwrite(ADD_XML2_KEY, sizeof(BYTE), sizeof(ADD_XML2_KEY)-1,     fp) < sizeof(ADD_XML2_KEY)-1 ) {
		MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
		fclose(fp);
		return FALSE;
	}
	fclose(fp);

	//EtoMailUI EtoWebUI tH_[̒ǉ
	WCSCPY(filename1, sizeof(filename1), tmp_folder);
	WCSCAT(filename1, sizeof(filename1), L"\\");
	WCSCAT(filename1, sizeof(filename1), ADD_FOLDER);
	if ( CreateDirectory(filename1, NULL) != TRUE ) {
		MessageBox(hWnd, L"ƗptH_[쐬o܂B", WIND_TITLE, MB_ICONSTOP | MB_OK);
		return FALSE;
	}

	//TutH_[̒ǉ1
	WCSCPY(filename1, sizeof(filename1), tmp_folder);
	WCSCAT(filename1, sizeof(filename1), L"\\");
	WCSCAT(filename1, sizeof(filename1), ADD_FOLDER);
	WCSCAT(filename1, sizeof(filename1), L"\\");
	WCSCAT(filename1, sizeof(filename1), ADD_SUBFOLDER1);
	if ( CreateDirectory(filename1, NULL) != TRUE ) {
		MessageBox(hWnd, L"ƗptH_[쐬o܂B", WIND_TITLE, MB_ICONSTOP | MB_OK);
		return FALSE;
	}

	//TutH_[̒ǉ2
	WCSCPY(filename1, sizeof(filename1), tmp_folder);
	WCSCAT(filename1, sizeof(filename1), L"\\");
	WCSCAT(filename1, sizeof(filename1), ADD_FOLDER);
	WCSCAT(filename1, sizeof(filename1), L"\\");
	WCSCAT(filename1, sizeof(filename1), ADD_SUBFOLDER2);
	if ( CreateDirectory(filename1, NULL) != TRUE ) {
		MessageBox(hWnd, L"ƗptH_[쐬o܂B", WIND_TITLE, MB_ICONSTOP | MB_OK);
		return FALSE;
	}

	//zipt@C̒ǉ1
	WCSCPY(filename1, sizeof(filename1), tmp_folder);
	WCSCAT(filename1, sizeof(filename1), L"\\");
	WCSCAT(filename1, sizeof(filename1), ADD_FOLDER);
	WCSCAT(filename1, sizeof(filename1), L"\\");
	WCSCAT(filename1, sizeof(filename1), ADD_ZIP1_FILE);
#if !defined(_MSC_VER) || _MSC_VER < 1400
	if ( (fp = _wfopen(filename1, L"wb")) == NULL ) {
#else
	if ( _wfopen_s(&fp, filename1, L"wb") != 0 ) {
#endif
		MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
		fclose(fp);
		return FALSE;
	}
//	write(fd, ADD_ZIP1_DATA1, sizeof(ADD_ZIP1_DATA1)-1);
//	write(fd, ADD_ZIP1_DATA2, sizeof(ADD_ZIP1_DATA2)-1);
	if ( fwrite(ADD_ZIP1_DATA1, sizeof(BYTE), sizeof(ADD_ZIP1_DATA1)-1, fp) < sizeof(ADD_ZIP1_DATA1)-1 ) {
		MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
		fclose(fp);
		return FALSE;
	}
	if ( fwrite(ADD_ZIP1_DATA2, sizeof(BYTE), sizeof(ADD_ZIP1_DATA2)-1, fp) < sizeof(ADD_ZIP1_DATA2)-1 ) {
		MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
		fclose(fp);
		return FALSE;
	}
	if ( chkflag[1] == 1 ) {
//		write(fd, ADD_ZIP1_DATA3, sizeof(ADD_ZIP1_DATA3)-1);
		if ( fwrite(ADD_ZIP1_DATA3, sizeof(BYTE), sizeof(ADD_ZIP1_DATA3)-1, fp) < sizeof(ADD_ZIP1_DATA3)-1 ) {
			MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
			fclose(fp);
			return FALSE;
		}
	}
	if ( chkflag[2] == 1 ) {
//		write(fd, ADD_ZIP1_DATA4, sizeof(ADD_ZIP1_DATA4)-1);
		if ( fwrite(ADD_ZIP1_DATA4, sizeof(BYTE), sizeof(ADD_ZIP1_DATA4)-1, fp) < sizeof(ADD_ZIP1_DATA4)-1 ) {
			MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
			fclose(fp);
			return FALSE;
		}
	}
//	write(fd, ADD_ZIP1_DATA5, sizeof(ADD_ZIP1_DATA5)-1);
	if ( fwrite(ADD_ZIP1_DATA5, sizeof(BYTE), sizeof(ADD_ZIP1_DATA5)-1, fp) < sizeof(ADD_ZIP1_DATA5)-1 ) {
		MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
		fclose(fp);
		return FALSE;
	}
	fclose(fp);

	//zipt@C̒ǉ2
	WCSCPY(filename1, sizeof(filename1), tmp_folder);
	WCSCAT(filename1, sizeof(filename1), L"\\");
	WCSCAT(filename1, sizeof(filename1), ADD_FOLDER);
	WCSCAT(filename1, sizeof(filename1), L"\\");
	WCSCAT(filename1, sizeof(filename1), ADD_SUBFOLDER1);
	WCSCAT(filename1, sizeof(filename1), L"\\");
	WCSCAT(filename1, sizeof(filename1), ADD_ZIP2_FILE);
#if !defined(_MSC_VER) || _MSC_VER < 1400
	if ( (fp = _wfopen(filename1, L"wb")) == NULL ) {
#else
	if ( _wfopen_s(&fp, filename1, L"wb") != 0 ) {
#endif
		MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
		fclose(fp);
		return FALSE;
	}
//	write(fd, ADD_ZIP2_DATA1, sizeof(ADD_ZIP2_DATA1)-1);
	if ( fwrite(ADD_ZIP2_DATA1, sizeof(BYTE), sizeof(ADD_ZIP2_DATA1)-1, fp) < sizeof(ADD_ZIP2_DATA1)-1 ) {
		MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
		fclose(fp);
		return FALSE;
	}
	if ( chkflag[1] == 1 ) {
//		write(fd, ADD_ZIP2_DATA2, sizeof(ADD_ZIP2_DATA2)-1);
//		write(fd, ADD_ZIP2_DATA3, sizeof(ADD_ZIP2_DATA3)-1);
//		write(fd, ADD_ZIP2_DATA4, sizeof(ADD_ZIP2_DATA4)-1);
		if ( fwrite(ADD_ZIP2_DATA2, sizeof(BYTE), sizeof(ADD_ZIP2_DATA2)-1, fp) < sizeof(ADD_ZIP2_DATA2)-1 ) {
			MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
			fclose(fp);
			return FALSE;
		}
		if ( fwrite(ADD_ZIP2_DATA3, sizeof(BYTE), sizeof(ADD_ZIP2_DATA3)-1, fp) < sizeof(ADD_ZIP2_DATA3)-1 ) {
			MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
			fclose(fp);
			return FALSE;
		}
		if ( fwrite(ADD_ZIP2_DATA4, sizeof(BYTE), sizeof(ADD_ZIP2_DATA4)-1, fp) < sizeof(ADD_ZIP2_DATA4)-1 ) {
			MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
			fclose(fp);
			return FALSE;
		}
	}
	if ( chkflag[2] == 1 ) {
//		write(fd, ADD_ZIP2_DATA5, sizeof(ADD_ZIP2_DATA5)-1);
//		write(fd, ADD_ZIP2_DATA6, sizeof(ADD_ZIP2_DATA6)-1);
//		write(fd, ADD_ZIP2_DATA7, sizeof(ADD_ZIP2_DATA7)-1);
		if ( fwrite(ADD_ZIP2_DATA5, sizeof(BYTE), sizeof(ADD_ZIP2_DATA5)-1, fp) < sizeof(ADD_ZIP2_DATA5)-1 ) {
			MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
			fclose(fp);
			return FALSE;
		}
		if ( fwrite(ADD_ZIP2_DATA6, sizeof(BYTE), sizeof(ADD_ZIP2_DATA6)-1, fp) < sizeof(ADD_ZIP2_DATA6)-1 ) {
			MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
			fclose(fp);
			return FALSE;
		}
		if ( fwrite(ADD_ZIP2_DATA7, sizeof(BYTE), sizeof(ADD_ZIP2_DATA7)-1, fp) < sizeof(ADD_ZIP2_DATA7)-1 ) {
			MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
			fclose(fp);
			return FALSE;
		}
	}
//	write(fd, ADD_ZIP2_DATA8, sizeof(ADD_ZIP2_DATA8)-1);
	if ( fwrite(ADD_ZIP2_DATA8, sizeof(BYTE), sizeof(ADD_ZIP2_DATA8)-1, fp) < sizeof(ADD_ZIP2_DATA8)-1 ) {
		MessageBox(hWnd, L"ҏWo܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
		fclose(fp);
		return FALSE;
	}
	fclose(fp);

	Sleep(1000);

	//摜t@C̃Rs[
	for(ib=0; ib<=1; ib++) {
		if ( chkflag[ib+1] == 1 ) {
			WCSCPY(filename1, sizeof(filename1), Toolkit_path);
			if ( chkflag[0] == 0 ) {
				WCSCAT(filename1, sizeof(filename1), WHITE_IMAGE);
			} else {
				WCSCAT(filename1, sizeof(filename1), SKELETON_IMAGE);
			}
			if ( ib == 0 ) {
				WCSCAT(filename1, sizeof(filename1), FROMJ_IMAGE);
			} else {
				WCSCAT(filename1, sizeof(filename1), FROME_IMAGE);
			}

			WCSCPY(filename2, sizeof(filename2), tmp_folder);
			WCSCAT(filename2, sizeof(filename2), L"\\");
			WCSCAT(filename2, sizeof(filename2), ADD_FOLDER);
			WCSCAT(filename2, sizeof(filename2), L"\\");
			WCSCAT(filename2, sizeof(filename2), ADD_SUBFOLDER2);
			WCSCAT(filename2, sizeof(filename2), L"\\");
			if ( ib == 0 ) {
				WCSCAT(filename2, sizeof(filename2), FROMJ_IMAGE);
			} else {
				WCSCAT(filename2, sizeof(filename2), FROME_IMAGE);
			}
			if(FileSizeGet(filename1) <= 0 )  {
				MessageBox(hWnd, L"摜t@C܂B", WIND_TITLE, MB_ICONSTOP | MB_OK);
				return FALSE;
			}

			if ( CopyFile(filename1, filename2, FALSE) != TRUE ) {
				MessageBox(hWnd, L"摜t@CRs[o܂łB", WIND_TITLE, MB_ICONSTOP | MB_OK);
				return FALSE;
			}
		}
	}

	return TRUE;
}
