//*****************************************************************************
//* Copyright (c) 2011-2013 Miday Workshop All rights reserved.
//*
//* File: WinCntl.cpp
//*****************************************************************************

#include <windows.h>
#include "Ribbon.h"
#include "resource.h"

extern unsigned int FileSizeGet(wchar_t *file_name);
extern int ReMake(HWND hWnd, wchar_t *ribbon_file, int *imgflag);
extern int Excel_Ver_get( );

wchar_t Addin_path[PATH_SIZE], Toolkit_path[PATH_SIZE], Temp_path[PATH_SIZE];

//==============================================================================
//WindowsNTnXPȍ~`FbN
//==============================================================================
bool GetWinXP() {
//߂l@TRUE  XPȍ~
//@@@@FALSE 2000ȑO
	OSVERSIONINFO osver;

	//\̂̏
	memset(&osver, 0, sizeof(OSVERSIONINFO));

	osver.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx((OSVERSIONINFO*)&osver);

	//NTn
	if ( osver.dwPlatformId == VER_PLATFORM_WIN32_NT ) {
		//Win Vistaȏォ
		if (osver.dwMajorVersion > 5 ) {// Vista=6
			return TRUE;
		}
		//Win XP  XP=5.1 2000=5
		if (osver.dwMajorVersion >= 5 && osver.dwMinorVersion >= 1 ) {
			return TRUE;
		}
		return FALSE;
	} else {
		return FALSE;
	}
}

//==============================================================================
//Ŕr
//==============================================================================
bool LowerCmp(const wchar_t *data1, const wchar_t *data2) {
//data1@r镶
//data2@r镶
//߂l@TRUE  vĂ
//@@@@FALSE vĂȂ
	unsigned int ia;
	for(ia=0; ia<wcslen(data1); ia++ ) {
		if ( tolower(data1[ia]) != tolower(data2[ia]) ) {
			return FALSE;
			break;
		}
	}
	return TRUE;
}

//==============================================================================
//AhCt@C̈ꗗo
//==============================================================================
void GetFileList(HWND hWnd, wchar_t *file_name, int *ic1, int *ic2) {
//hWnd@@@@EChEnh
//*file_name@AhCt@CpX
//*ic1@@@@AhCt@C̐
//*ic2@@@@Excel2007ȍ~̃AhCt@C̐
	wchar_t data[500];
	WIN32_FIND_DATA FindFileData;
	HANDLE hndl;
	int ix;//, iy;

	*ic1 = 0;
	*ic2 = 0;

//	for(iy=0; iy<=1; iy++) {
		WCSCPY(data, sizeof(data), file_name);
//		if ( iy == 0 ) {
//			wcscat(data, L"*.xlam");
//		} else {
			WCSCAT(data, sizeof(data), L"*.xla");
//		}
		hndl = FindFirstFile( data, &FindFileData );
		for(;;) {//t@CȂȂ΃u[N
			if ( hndl != INVALID_HANDLE_VALUE ) {
				//R{{bNXɒǉ
				ix = SendMessage(GetDlgItem(hWnd, IDC_COMBO1), CB_ADDSTRING, 0, (LPARAM)FindFileData.cFileName);
//				if ( iy == 0 ) {
//					*ic1 = *ic1 + 1;
//				} else {
//					*ic2 = *ic2 + 1;
//				}
				*ic1 = *ic1 + 1;
				if ( LowerCmp(&FindFileData.cFileName[wcslen(FindFileData.cFileName)-5], L".xlam") == TRUE ) {
					*ic2 = *ic2 + 1;
				}
				if ( FindNextFile(hndl, &FindFileData) == false ) {
					break;
				}
			} else {
				break;
			}
		}
		FindClose(hndl);
//	}

	return;
}

//==============================================================================
//R[obN֐
//==============================================================================
LRESULT CALLBACK DlgProc(HWND hWnd,UINT message, WPARAM wParam, LPARAM IParam){
	int chkflag[3], ix1, iy1, iy2;
	bool iv;
	wchar_t filename[100], filepath[500], work1[500], work2[500];

	switch (message){
	case WM_INITDIALOG:
		SetWindowText(hWnd, WIND_TITLE);
		SetWindowText(GetDlgItem(hWnd, IDC_CHECK2), CHK_TITLE2);
		SetWindowText(GetDlgItem(hWnd, IDC_CHECK3), CHK_TITLE3);
		SendMessage(GetDlgItem(hWnd, IDC_CHECK2), BM_SETCHECK, BST_CHECKED, 0);
		iv = GetWinXP();
		ix1 = Excel_Ver_get( );
//if ( iv != 0 ) MessageBox(NULL,L"XPȏ",L"",0);
//if ( ix1 >= 2007 ) MessageBox(NULL,L"2007ȏ",L"",0);

		//%APPDATA%\Microsoft\AddIns@AhC̃tH_[
		ExpandEnvironmentStrings(L"%APPDATA%", Addin_path, PATH_SIZE-1);
		WCSCAT(Addin_path, sizeof(Addin_path), L"\\Microsoft\\AddIns\\");

		GetFileList(hWnd, Addin_path, &iy1, &iy2);

		//Office2007 || WindowsXP || 2007ΉAhCȂ
		if ( ix1 < 2007 || iv == FALSE || iy1 == 0 ) {
			EnableWindow(GetDlgItem(hWnd, IDC_BUTTON1), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDC_BUTTON2), FALSE);
			if ( iy1 == 0 ) {
				MessageBox(hWnd, L"{o^̏oAhCt@C܂B", WIND_TITLE, MB_ICONINFORMATION | MB_OK);
			} else {
				MessageBox(hWnd, L"{o^ɂ́AWindowsXPȏExcel2007ȏ̊KvłB", WIND_TITLE, MB_ICONINFORMATION | MB_OK);
			}
		} else {
			if ( GetTempPath(PATH_SIZE-1, Temp_path) == 0 ) {
				MessageBox(hWnd, L"ꎞt@C̃tH_[荞߂Ȃ̂Ń{o^͏o܂B", WIND_TITLE, MB_ICONSTOP | MB_OK);
				EnableWindow(GetDlgItem(hWnd, IDC_BUTTON1), FALSE);
				EnableWindow(GetDlgItem(hWnd, IDC_BUTTON2), FALSE);
			} else {
				Temp_path[wcslen(Temp_path)-1] = L'\0';  //\\͌ŕt
				if ( FileSizeGet(Temp_path) == 0 ) {
					MessageBox(hWnd, L"ꎞt@C̃tH_[݂Ȃ̂Ń{o^͏o܂B", WIND_TITLE, MB_ICONSTOP | MB_OK);
					EnableWindow(GetDlgItem(hWnd, IDC_BUTTON1), FALSE);
					EnableWindow(GetDlgItem(hWnd, IDC_BUTTON2), FALSE);
				}
			}
		}
		//AhCȂ@OfficeWindows̃o[W͕s
		if ( iy1 + iy2 == 0 ) {
			EnableWindow(GetDlgItem(hWnd, IDC_BUTTON3), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDC_COMBO1), FALSE);
		} else {
			SendMessage(GetDlgItem(hWnd, IDC_COMBO1), CB_SETCURSEL, 0, 1);
		}

		//c[Lbg̃pXo
		GetModuleFileName(NULL, Toolkit_path, PATH_SIZE-1);
		for(ix1=wcslen(Toolkit_path); ix1>0; ix1--) {
			if( Toolkit_path[ix1] == L'\\' ) {
				Toolkit_path[ix1+1] = L'\0';
				break;
			}
		}
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam)){
		case IDC_BUTTON1://{o^
			chkflag[0] = SendMessage(GetDlgItem(hWnd, IDC_CHECK1), BM_GETCHECK, 0, 0);
			chkflag[1] = SendMessage(GetDlgItem(hWnd, IDC_CHECK2), BM_GETCHECK, 0, 0);
			chkflag[2] = SendMessage(GetDlgItem(hWnd, IDC_CHECK3), BM_GETCHECK, 0, 0);

			if ( chkflag[1] != 1 && chkflag[2] != 1 ) {
#ifdef ETOMAIL
				MessageBox(hWnd, L"{łpł̂ꂩ͗`FbNĉB", WIND_TITLE, MB_ICONSTOP | MB_OK);
#else
				MessageBox(hWnd, L"WikiłHtmlł̂ꂩ͗`FbNĉB", WIND_TITLE, MB_ICONSTOP | MB_OK);
#endif
				break;
			}

			if ( MessageBox(hWnd, L"I܂ŁȂ͍sȂŉB\n\nAhCt@CɃ{̋@\ǉĂ낵łH", WIND_TITLE, MB_ICONQUESTION | MB_YESNO) == IDNO) {
				break;
			}
			ix1 = SendMessage(GetDlgItem(hWnd, IDC_COMBO1), CB_GETCURSEL, 0, 0);
			SendMessage(GetDlgItem(hWnd, IDC_COMBO1), CB_GETLBTEXT, ix1, (LPARAM)filename);

			if ( LowerCmp(&filename[wcslen(filename)-5], L".xlam") != TRUE ) {
				MessageBox(hWnd, L"Excel2007ȍ~̌`̃AhCw肵ĉB", WIND_TITLE, MB_ICONSTOP | MB_OK);
				break;
			}

			ReMake(hWnd, filename, chkflag);
			break;
		case IDC_BUTTON2://
			if ( MessageBox(hWnd, L"AhCt@CAhC̃tH_[ɕĂ낵łH", WIND_TITLE, MB_ICONQUESTION | MB_YESNO) == IDNO) {
				break;
			}
			SetWindowText(GetDlgItem(hWnd, IDC_STATICS), L"");
			ix1 = SendMessage(GetDlgItem(hWnd, IDC_COMBO1), CB_GETCURSEL, 0, 0);
			SendMessage(GetDlgItem(hWnd, IDC_COMBO1), CB_GETLBTEXT, ix1, (LPARAM)filename);

			if ( LowerCmp(&filename[wcslen(filename)-5], L".xlam") != TRUE ) {
				MessageBox(hWnd, L"Excel2007ȍ~̌`̃AhCw肵ĉB", WIND_TITLE, MB_ICONSTOP | MB_OK);
				break;
			}

			WCSCPY(work1, sizeof(work1), Toolkit_path);
			WCSCAT(work1, sizeof(work1), filename);

			WCSCPY(work2, sizeof(work2), Addin_path);
			WCSCAT(work2, sizeof(work2), filename);

			if(FileSizeGet(work1) <= 0 )  {
				MessageBox(hWnd, L"w肳ꂽt@ĆAobNAbvt@C܂B", WIND_TITLE, MB_ICONSTOP | MB_OK);
				break;
			}

			CopyFile(work1, work2, FALSE);
			MessageBox(hWnd, L"ƂI܂B", WIND_TITLE, MB_ICONINFORMATION | MB_OK);
			SetWindowText(GetDlgItem(hWnd, IDC_STATICS), L"I܂");
			break;
		case IDC_BUTTON3://폜
			if ( MessageBox(hWnd, L"AhC̃tH_[AhCt@C폜Ă낵łH", WIND_TITLE, MB_ICONQUESTION | MB_YESNO) == IDNO) {
				break;
			}
			SetWindowText(GetDlgItem(hWnd, IDC_STATICS), L"폜");
			ix1 = SendMessage(GetDlgItem(hWnd, IDC_COMBO1), CB_GETCURSEL, 0, 0);
			SendMessage(GetDlgItem(hWnd, IDC_COMBO1), CB_GETLBTEXT, ix1, (LPARAM)filename);
			WCSCPY(filepath, sizeof(filepath), Addin_path);
			WCSCAT(filepath, sizeof(filepath), filename);
			DeleteFile(filepath);

			//R{{bNX̍ڂč\z
			SendMessage(GetDlgItem(hWnd, IDC_COMBO1), CB_RESETCONTENT, 0, 0);
			GetFileList(hWnd, Addin_path, &iy1, &iy2);

			if ( iy1 + iy2 == 0 ) {
				EnableWindow(GetDlgItem(hWnd, IDC_BUTTON3), FALSE);
				EnableWindow(GetDlgItem(hWnd, IDC_COMBO1), FALSE);
			} else {
				SendMessage(GetDlgItem(hWnd, IDC_COMBO1), CB_SETCURSEL, 0, 1);
			}
			MessageBox(hWnd, L"폜ƂI܂B", WIND_TITLE, MB_ICONINFORMATION | MB_OK);
			SetWindowText(GetDlgItem(hWnd, IDC_STATICS), L"I܂");
			break;
		case IDC_BUTTON4://I
			PostMessage(hWnd, WM_CLOSE, NULL, NULL);
			break;
		}
		break;
	case WM_CLOSE:
		EndDialog(hWnd,WM_CLOSE);
		break;
	}
	return FALSE;
}

//==============================================================================
//C֐
//==============================================================================
int PASCAL wWinMain(HINSTANCE hInstance, HINSTANCE hPreInstance,
					LPSTR lpCmdLine, int nCmdShow) {

	DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), NULL, (DLGPROC)DlgProc);
	return 0;
}
